/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/
package jp.co.ntt.lms.installer.core;

import java.util.logging.Logger;

import jp.co.ntt.lms.installer.core.util.InstallerUiUtil;
import jp.co.ntt.lms.installer.util.LoggerUtil;
import jp.co.ntt.lms.installer.util.XmlUtil;

import org.w3c.dom.Document;

/**
 * インストーラ・メインコントロールクラス。<br>
 *
 * @author T.Nishiki
 */
public class InstallerControl {
	/**
	 * ログ出力オブジェクト。
	 */
	private static Logger _logger;

	/**
	 * スタティック・イニシャライザ。<br>
	 * ログ出力オブジェクトを取得します。
	 */
	static {
		_logger = LoggerUtil.getLogger(InstallerControl.class);
	}

	/**
	 * インストーラ共通データ・オブジェクト。
	 */
	private InstallerValues _values;

	/**
	 * コンストラクタ。<br>
	 * @param propertyURI インストーラのプロパティXMLにアクセスするためのURI。
	 * @throws InstallerException プロパティの取得に失敗した場合。
	 */
	public InstallerControl(String propertyURI)
			throws InstallerException {
		LoggerUtil.methodHead(
			_logger, "InstallerControl(" + propertyURI + ")");

		try {
			Document doc
				= XmlUtil.convertXmlResourceToDocument(propertyURI);
			_values = new InstallerValues(doc);
		}
		catch (InstallerException e) {
			throw e;
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}

		LoggerUtil.methodTail(
			_logger, "InstallerControl(" + propertyURI + ")");
	}

	/**
	 * インストール実行メソッド。<br>
	 * @throws InstallerException プロパティの取得に失敗した場合。
	 */
	public void install() throws InstallerException {
		LoggerUtil.methodHead(_logger, "install()");

		try {
			InstallerAction[] actions = _values.getActions();

			for (int i = 0; i < actions.length; i++) {
				if (actions[i].isSkipped(_values)) {
					continue;
				}

				InstallerActionValue actionValue = actions[i].action(_values);
				_values.setActionValue(actions[i], actionValue);
			}
		}
		catch (Throwable e) {
			LoggerUtil.throwable(_logger, e);
			// エラーメッセージ出力
			InstallerUiUtil.outputMessage(_values, "common.error", true);

			// 復元アクションを実行
			InstallerAction[] actions = _values.getRestreActions();

			for (int i = 0; i < actions.length; i++) {
				if (actions[i].isSkipped(_values)) {
					continue;
				}

				InstallerActionValue actionValue = actions[i].action(_values);
				_values.setActionValue(actions[i], actionValue);
			}
		}

		LoggerUtil.methodTail(_logger, "install()");
	}
}
